// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_spatem_ts_msgs:msg/IntersectionStatusObject.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_spatem_ts_msgs/msg/intersection_status_object.h"


#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__INTERSECTION_STATUS_OBJECT__STRUCT_H_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__INTERSECTION_STATUS_OBJECT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__SIZE_BITS = 16
};

/// Constant 'BIT_INDEX_MANUAL_CONTROL_IS_ENABLED'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_MANUAL_CONTROL_IS_ENABLED = 0
};

/// Constant 'BIT_INDEX_STOP_TIME_IS_ACTIVATED'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_STOP_TIME_IS_ACTIVATED = 1
};

/// Constant 'BIT_INDEX_FAILURE_FLASH'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_FAILURE_FLASH = 2
};

/// Constant 'BIT_INDEX_PREEMPT_IS_ACTIVE'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_PREEMPT_IS_ACTIVE = 3
};

/// Constant 'BIT_INDEX_SIGNAL_PRIORITY_IS_ACTIVE'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_SIGNAL_PRIORITY_IS_ACTIVE = 4
};

/// Constant 'BIT_INDEX_FIXED_TIME_OPERATION'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_FIXED_TIME_OPERATION = 5
};

/// Constant 'BIT_INDEX_TRAFFIC_DEPENDENT_OPERATION'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_TRAFFIC_DEPENDENT_OPERATION = 6
};

/// Constant 'BIT_INDEX_STANDBY_OPERATION'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_STANDBY_OPERATION = 7
};

/// Constant 'BIT_INDEX_FAILURE_MODE'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_FAILURE_MODE = 8
};

/// Constant 'BIT_INDEX_OFF'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_OFF = 9
};

/// Constant 'BIT_INDEX_RECENT_MA_PMESSAGE_UPDATE'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_RECENT_MA_PMESSAGE_UPDATE = 10
};

/// Constant 'BIT_INDEX_RECENT_CHANGE_IN_MA_PASSIGNED_LANES_I_DS_USED'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_RECENT_CHANGE_IN_MA_PASSIGNED_LANES_I_DS_USED = 11
};

/// Constant 'BIT_INDEX_NO_VALID_MA_PIS_AVAILABLE_AT_THIS_TIME'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_NO_VALID_MA_PIS_AVAILABLE_AT_THIS_TIME = 12
};

/// Constant 'BIT_INDEX_NO_VALID_SPA_TIS_AVAILABLE_AT_THIS_TIME'.
enum
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__BIT_INDEX_NO_VALID_SPA_TIS_AVAILABLE_AT_THIS_TIME = 13
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/IntersectionStatusObject in the package etsi_its_spatem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   spatem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// IntersectionStatusObject ::= BIT STRING {
  ///   manualControlIsEnabled                (0),
  ///   stopTimeIsActivated                   (1),
  ///   failureFlash                          (2),
  ///   preemptIsActive                       (3),
  ///   signalPriorityIsActive                (4),
  ///   fixedTimeOperation                    (5),
  ///   trafficDependentOperation             (6),
  ///   standbyOperation                      (7),
  ///   failureMode                           (8),
  ///   off                                   (9),
  ///   recentMAPmessageUpdate                (10),
  ///   recentChangeInMAPassignedLanesIDsUsed (11),
  ///   noValidMAPisAvailableAtThisTime       (12),
  ///   noValidSPATisAvailableAtThisTime      (13)
  /// } (SIZE(16))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject;

// Struct for a sequence of etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject.
typedef struct etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__Sequence
{
  etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_spatem_ts_msgs__msg__IntersectionStatusObject__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__INTERSECTION_STATUS_OBJECT__STRUCT_H_
