// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_spatem_ts_msgs:msg/MovementState.idl
// generated code does not contain a copyright notice
#include "etsi_its_spatem_ts_msgs/msg/detail/movement_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `movement_name`
#include "etsi_its_spatem_ts_msgs/msg/detail/descriptive_name__functions.h"
// Member `signal_group`
#include "etsi_its_spatem_ts_msgs/msg/detail/signal_group_id__functions.h"
// Member `state_time_speed`
#include "etsi_its_spatem_ts_msgs/msg/detail/movement_event_list__functions.h"
// Member `maneuver_assist_list`
#include "etsi_its_spatem_ts_msgs/msg/detail/maneuver_assist_list__functions.h"

bool
etsi_its_spatem_ts_msgs__msg__MovementState__init(etsi_its_spatem_ts_msgs__msg__MovementState * msg)
{
  if (!msg) {
    return false;
  }
  // movement_name
  if (!etsi_its_spatem_ts_msgs__msg__DescriptiveName__init(&msg->movement_name)) {
    etsi_its_spatem_ts_msgs__msg__MovementState__fini(msg);
    return false;
  }
  // movement_name_is_present
  // signal_group
  if (!etsi_its_spatem_ts_msgs__msg__SignalGroupID__init(&msg->signal_group)) {
    etsi_its_spatem_ts_msgs__msg__MovementState__fini(msg);
    return false;
  }
  // state_time_speed
  if (!etsi_its_spatem_ts_msgs__msg__MovementEventList__init(&msg->state_time_speed)) {
    etsi_its_spatem_ts_msgs__msg__MovementState__fini(msg);
    return false;
  }
  // maneuver_assist_list
  if (!etsi_its_spatem_ts_msgs__msg__ManeuverAssistList__init(&msg->maneuver_assist_list)) {
    etsi_its_spatem_ts_msgs__msg__MovementState__fini(msg);
    return false;
  }
  // maneuver_assist_list_is_present
  return true;
}

void
etsi_its_spatem_ts_msgs__msg__MovementState__fini(etsi_its_spatem_ts_msgs__msg__MovementState * msg)
{
  if (!msg) {
    return;
  }
  // movement_name
  etsi_its_spatem_ts_msgs__msg__DescriptiveName__fini(&msg->movement_name);
  // movement_name_is_present
  // signal_group
  etsi_its_spatem_ts_msgs__msg__SignalGroupID__fini(&msg->signal_group);
  // state_time_speed
  etsi_its_spatem_ts_msgs__msg__MovementEventList__fini(&msg->state_time_speed);
  // maneuver_assist_list
  etsi_its_spatem_ts_msgs__msg__ManeuverAssistList__fini(&msg->maneuver_assist_list);
  // maneuver_assist_list_is_present
}

bool
etsi_its_spatem_ts_msgs__msg__MovementState__are_equal(const etsi_its_spatem_ts_msgs__msg__MovementState * lhs, const etsi_its_spatem_ts_msgs__msg__MovementState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // movement_name
  if (!etsi_its_spatem_ts_msgs__msg__DescriptiveName__are_equal(
      &(lhs->movement_name), &(rhs->movement_name)))
  {
    return false;
  }
  // movement_name_is_present
  if (lhs->movement_name_is_present != rhs->movement_name_is_present) {
    return false;
  }
  // signal_group
  if (!etsi_its_spatem_ts_msgs__msg__SignalGroupID__are_equal(
      &(lhs->signal_group), &(rhs->signal_group)))
  {
    return false;
  }
  // state_time_speed
  if (!etsi_its_spatem_ts_msgs__msg__MovementEventList__are_equal(
      &(lhs->state_time_speed), &(rhs->state_time_speed)))
  {
    return false;
  }
  // maneuver_assist_list
  if (!etsi_its_spatem_ts_msgs__msg__ManeuverAssistList__are_equal(
      &(lhs->maneuver_assist_list), &(rhs->maneuver_assist_list)))
  {
    return false;
  }
  // maneuver_assist_list_is_present
  if (lhs->maneuver_assist_list_is_present != rhs->maneuver_assist_list_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_spatem_ts_msgs__msg__MovementState__copy(
  const etsi_its_spatem_ts_msgs__msg__MovementState * input,
  etsi_its_spatem_ts_msgs__msg__MovementState * output)
{
  if (!input || !output) {
    return false;
  }
  // movement_name
  if (!etsi_its_spatem_ts_msgs__msg__DescriptiveName__copy(
      &(input->movement_name), &(output->movement_name)))
  {
    return false;
  }
  // movement_name_is_present
  output->movement_name_is_present = input->movement_name_is_present;
  // signal_group
  if (!etsi_its_spatem_ts_msgs__msg__SignalGroupID__copy(
      &(input->signal_group), &(output->signal_group)))
  {
    return false;
  }
  // state_time_speed
  if (!etsi_its_spatem_ts_msgs__msg__MovementEventList__copy(
      &(input->state_time_speed), &(output->state_time_speed)))
  {
    return false;
  }
  // maneuver_assist_list
  if (!etsi_its_spatem_ts_msgs__msg__ManeuverAssistList__copy(
      &(input->maneuver_assist_list), &(output->maneuver_assist_list)))
  {
    return false;
  }
  // maneuver_assist_list_is_present
  output->maneuver_assist_list_is_present = input->maneuver_assist_list_is_present;
  return true;
}

etsi_its_spatem_ts_msgs__msg__MovementState *
etsi_its_spatem_ts_msgs__msg__MovementState__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_spatem_ts_msgs__msg__MovementState * msg = (etsi_its_spatem_ts_msgs__msg__MovementState *)allocator.allocate(sizeof(etsi_its_spatem_ts_msgs__msg__MovementState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_spatem_ts_msgs__msg__MovementState));
  bool success = etsi_its_spatem_ts_msgs__msg__MovementState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_spatem_ts_msgs__msg__MovementState__destroy(etsi_its_spatem_ts_msgs__msg__MovementState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_spatem_ts_msgs__msg__MovementState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_spatem_ts_msgs__msg__MovementState__Sequence__init(etsi_its_spatem_ts_msgs__msg__MovementState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_spatem_ts_msgs__msg__MovementState * data = NULL;

  if (size) {
    data = (etsi_its_spatem_ts_msgs__msg__MovementState *)allocator.zero_allocate(size, sizeof(etsi_its_spatem_ts_msgs__msg__MovementState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_spatem_ts_msgs__msg__MovementState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_spatem_ts_msgs__msg__MovementState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_spatem_ts_msgs__msg__MovementState__Sequence__fini(etsi_its_spatem_ts_msgs__msg__MovementState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_spatem_ts_msgs__msg__MovementState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_spatem_ts_msgs__msg__MovementState__Sequence *
etsi_its_spatem_ts_msgs__msg__MovementState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_spatem_ts_msgs__msg__MovementState__Sequence * array = (etsi_its_spatem_ts_msgs__msg__MovementState__Sequence *)allocator.allocate(sizeof(etsi_its_spatem_ts_msgs__msg__MovementState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_spatem_ts_msgs__msg__MovementState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_spatem_ts_msgs__msg__MovementState__Sequence__destroy(etsi_its_spatem_ts_msgs__msg__MovementState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_spatem_ts_msgs__msg__MovementState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_spatem_ts_msgs__msg__MovementState__Sequence__are_equal(const etsi_its_spatem_ts_msgs__msg__MovementState__Sequence * lhs, const etsi_its_spatem_ts_msgs__msg__MovementState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_spatem_ts_msgs__msg__MovementState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_spatem_ts_msgs__msg__MovementState__Sequence__copy(
  const etsi_its_spatem_ts_msgs__msg__MovementState__Sequence * input,
  etsi_its_spatem_ts_msgs__msg__MovementState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_spatem_ts_msgs__msg__MovementState);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_spatem_ts_msgs__msg__MovementState * data =
      (etsi_its_spatem_ts_msgs__msg__MovementState *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_spatem_ts_msgs__msg__MovementState__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_spatem_ts_msgs__msg__MovementState__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_spatem_ts_msgs__msg__MovementState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
