// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_spatem_ts_msgs:msg/SPAT.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_spatem_ts_msgs/msg/spat.hpp"


#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__SPAT__TRAITS_HPP_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__SPAT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_spatem_ts_msgs/msg/detail/spat__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'time_stamp'
#include "etsi_its_spatem_ts_msgs/msg/detail/minute_of_the_year__traits.hpp"
// Member 'name'
#include "etsi_its_spatem_ts_msgs/msg/detail/descriptive_name__traits.hpp"
// Member 'intersections'
#include "etsi_its_spatem_ts_msgs/msg/detail/intersection_state_list__traits.hpp"

namespace etsi_its_spatem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SPAT & msg,
  std::ostream & out)
{
  out << "{";
  // member: time_stamp
  {
    out << "time_stamp: ";
    to_flow_style_yaml(msg.time_stamp, out);
    out << ", ";
  }

  // member: time_stamp_is_present
  {
    out << "time_stamp_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.time_stamp_is_present, out);
    out << ", ";
  }

  // member: name
  {
    out << "name: ";
    to_flow_style_yaml(msg.name, out);
    out << ", ";
  }

  // member: name_is_present
  {
    out << "name_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.name_is_present, out);
    out << ", ";
  }

  // member: intersections
  {
    out << "intersections: ";
    to_flow_style_yaml(msg.intersections, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SPAT & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: time_stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_stamp:\n";
    to_block_style_yaml(msg.time_stamp, out, indentation + 2);
  }

  // member: time_stamp_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_stamp_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.time_stamp_is_present, out);
    out << "\n";
  }

  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name:\n";
    to_block_style_yaml(msg.name, out, indentation + 2);
  }

  // member: name_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.name_is_present, out);
    out << "\n";
  }

  // member: intersections
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "intersections:\n";
    to_block_style_yaml(msg.intersections, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SPAT & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_spatem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_spatem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_spatem_ts_msgs::msg::SPAT & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_spatem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_spatem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_spatem_ts_msgs::msg::SPAT & msg)
{
  return etsi_its_spatem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_spatem_ts_msgs::msg::SPAT>()
{
  return "etsi_its_spatem_ts_msgs::msg::SPAT";
}

template<>
inline const char * name<etsi_its_spatem_ts_msgs::msg::SPAT>()
{
  return "etsi_its_spatem_ts_msgs/msg/SPAT";
}

template<>
struct has_fixed_size<etsi_its_spatem_ts_msgs::msg::SPAT>
  : std::integral_constant<bool, has_fixed_size<etsi_its_spatem_ts_msgs::msg::DescriptiveName>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::IntersectionStateList>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::MinuteOfTheYear>::value> {};

template<>
struct has_bounded_size<etsi_its_spatem_ts_msgs::msg::SPAT>
  : std::integral_constant<bool, has_bounded_size<etsi_its_spatem_ts_msgs::msg::DescriptiveName>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::IntersectionStateList>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::MinuteOfTheYear>::value> {};

template<>
struct is_message<etsi_its_spatem_ts_msgs::msg::SPAT>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__SPAT__TRAITS_HPP_
