// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_spatem_ts_msgs:msg/TimeChangeDetails.idl
// generated code does not contain a copyright notice
#include "etsi_its_spatem_ts_msgs/msg/detail/time_change_details__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `start_time`
// Member `min_end_time`
// Member `max_end_time`
// Member `likely_time`
// Member `next_time`
#include "etsi_its_spatem_ts_msgs/msg/detail/time_mark__functions.h"
// Member `confidence`
#include "etsi_its_spatem_ts_msgs/msg/detail/time_interval_confidence__functions.h"

bool
etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__init(etsi_its_spatem_ts_msgs__msg__TimeChangeDetails * msg)
{
  if (!msg) {
    return false;
  }
  // start_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__init(&msg->start_time)) {
    etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__fini(msg);
    return false;
  }
  // start_time_is_present
  // min_end_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__init(&msg->min_end_time)) {
    etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__fini(msg);
    return false;
  }
  // max_end_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__init(&msg->max_end_time)) {
    etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__fini(msg);
    return false;
  }
  // max_end_time_is_present
  // likely_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__init(&msg->likely_time)) {
    etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__fini(msg);
    return false;
  }
  // likely_time_is_present
  // confidence
  if (!etsi_its_spatem_ts_msgs__msg__TimeIntervalConfidence__init(&msg->confidence)) {
    etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__fini(msg);
    return false;
  }
  // confidence_is_present
  // next_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__init(&msg->next_time)) {
    etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__fini(msg);
    return false;
  }
  // next_time_is_present
  return true;
}

void
etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__fini(etsi_its_spatem_ts_msgs__msg__TimeChangeDetails * msg)
{
  if (!msg) {
    return;
  }
  // start_time
  etsi_its_spatem_ts_msgs__msg__TimeMark__fini(&msg->start_time);
  // start_time_is_present
  // min_end_time
  etsi_its_spatem_ts_msgs__msg__TimeMark__fini(&msg->min_end_time);
  // max_end_time
  etsi_its_spatem_ts_msgs__msg__TimeMark__fini(&msg->max_end_time);
  // max_end_time_is_present
  // likely_time
  etsi_its_spatem_ts_msgs__msg__TimeMark__fini(&msg->likely_time);
  // likely_time_is_present
  // confidence
  etsi_its_spatem_ts_msgs__msg__TimeIntervalConfidence__fini(&msg->confidence);
  // confidence_is_present
  // next_time
  etsi_its_spatem_ts_msgs__msg__TimeMark__fini(&msg->next_time);
  // next_time_is_present
}

bool
etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__are_equal(const etsi_its_spatem_ts_msgs__msg__TimeChangeDetails * lhs, const etsi_its_spatem_ts_msgs__msg__TimeChangeDetails * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // start_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__are_equal(
      &(lhs->start_time), &(rhs->start_time)))
  {
    return false;
  }
  // start_time_is_present
  if (lhs->start_time_is_present != rhs->start_time_is_present) {
    return false;
  }
  // min_end_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__are_equal(
      &(lhs->min_end_time), &(rhs->min_end_time)))
  {
    return false;
  }
  // max_end_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__are_equal(
      &(lhs->max_end_time), &(rhs->max_end_time)))
  {
    return false;
  }
  // max_end_time_is_present
  if (lhs->max_end_time_is_present != rhs->max_end_time_is_present) {
    return false;
  }
  // likely_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__are_equal(
      &(lhs->likely_time), &(rhs->likely_time)))
  {
    return false;
  }
  // likely_time_is_present
  if (lhs->likely_time_is_present != rhs->likely_time_is_present) {
    return false;
  }
  // confidence
  if (!etsi_its_spatem_ts_msgs__msg__TimeIntervalConfidence__are_equal(
      &(lhs->confidence), &(rhs->confidence)))
  {
    return false;
  }
  // confidence_is_present
  if (lhs->confidence_is_present != rhs->confidence_is_present) {
    return false;
  }
  // next_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__are_equal(
      &(lhs->next_time), &(rhs->next_time)))
  {
    return false;
  }
  // next_time_is_present
  if (lhs->next_time_is_present != rhs->next_time_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__copy(
  const etsi_its_spatem_ts_msgs__msg__TimeChangeDetails * input,
  etsi_its_spatem_ts_msgs__msg__TimeChangeDetails * output)
{
  if (!input || !output) {
    return false;
  }
  // start_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__copy(
      &(input->start_time), &(output->start_time)))
  {
    return false;
  }
  // start_time_is_present
  output->start_time_is_present = input->start_time_is_present;
  // min_end_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__copy(
      &(input->min_end_time), &(output->min_end_time)))
  {
    return false;
  }
  // max_end_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__copy(
      &(input->max_end_time), &(output->max_end_time)))
  {
    return false;
  }
  // max_end_time_is_present
  output->max_end_time_is_present = input->max_end_time_is_present;
  // likely_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__copy(
      &(input->likely_time), &(output->likely_time)))
  {
    return false;
  }
  // likely_time_is_present
  output->likely_time_is_present = input->likely_time_is_present;
  // confidence
  if (!etsi_its_spatem_ts_msgs__msg__TimeIntervalConfidence__copy(
      &(input->confidence), &(output->confidence)))
  {
    return false;
  }
  // confidence_is_present
  output->confidence_is_present = input->confidence_is_present;
  // next_time
  if (!etsi_its_spatem_ts_msgs__msg__TimeMark__copy(
      &(input->next_time), &(output->next_time)))
  {
    return false;
  }
  // next_time_is_present
  output->next_time_is_present = input->next_time_is_present;
  return true;
}

etsi_its_spatem_ts_msgs__msg__TimeChangeDetails *
etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_spatem_ts_msgs__msg__TimeChangeDetails * msg = (etsi_its_spatem_ts_msgs__msg__TimeChangeDetails *)allocator.allocate(sizeof(etsi_its_spatem_ts_msgs__msg__TimeChangeDetails), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_spatem_ts_msgs__msg__TimeChangeDetails));
  bool success = etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__destroy(etsi_its_spatem_ts_msgs__msg__TimeChangeDetails * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence__init(etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_spatem_ts_msgs__msg__TimeChangeDetails * data = NULL;

  if (size) {
    data = (etsi_its_spatem_ts_msgs__msg__TimeChangeDetails *)allocator.zero_allocate(size, sizeof(etsi_its_spatem_ts_msgs__msg__TimeChangeDetails), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence__fini(etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence *
etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence * array = (etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence *)allocator.allocate(sizeof(etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence__destroy(etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence__are_equal(const etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence * lhs, const etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence__copy(
  const etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence * input,
  etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_spatem_ts_msgs__msg__TimeChangeDetails);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_spatem_ts_msgs__msg__TimeChangeDetails * data =
      (etsi_its_spatem_ts_msgs__msg__TimeChangeDetails *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_spatem_ts_msgs__msg__TimeChangeDetails__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
