// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_spatem_ts_msgs:msg/AdvisorySpeed.idl
// generated code does not contain a copyright notice
#include "etsi_its_spatem_ts_msgs/msg/detail/advisory_speed__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `type`
#include "etsi_its_spatem_ts_msgs/msg/detail/advisory_speed_type__functions.h"
// Member `speed`
#include "etsi_its_spatem_ts_msgs/msg/detail/speed_advice__functions.h"
// Member `confidence`
#include "etsi_its_spatem_ts_msgs/msg/detail/speed_confidence_dsrc__functions.h"
// Member `distance`
#include "etsi_its_spatem_ts_msgs/msg/detail/zone_length__functions.h"
// Member `cls`
#include "etsi_its_spatem_ts_msgs/msg/detail/restriction_class_id__functions.h"

bool
etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__init(etsi_its_spatem_ts_msgs__msg__AdvisorySpeed * msg)
{
  if (!msg) {
    return false;
  }
  // type
  if (!etsi_its_spatem_ts_msgs__msg__AdvisorySpeedType__init(&msg->type)) {
    etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__fini(msg);
    return false;
  }
  // speed
  if (!etsi_its_spatem_ts_msgs__msg__SpeedAdvice__init(&msg->speed)) {
    etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__fini(msg);
    return false;
  }
  // speed_is_present
  // confidence
  if (!etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__init(&msg->confidence)) {
    etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__fini(msg);
    return false;
  }
  // confidence_is_present
  // distance
  if (!etsi_its_spatem_ts_msgs__msg__ZoneLength__init(&msg->distance)) {
    etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__fini(msg);
    return false;
  }
  // distance_is_present
  // cls
  if (!etsi_its_spatem_ts_msgs__msg__RestrictionClassID__init(&msg->cls)) {
    etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__fini(msg);
    return false;
  }
  // cls_is_present
  return true;
}

void
etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__fini(etsi_its_spatem_ts_msgs__msg__AdvisorySpeed * msg)
{
  if (!msg) {
    return;
  }
  // type
  etsi_its_spatem_ts_msgs__msg__AdvisorySpeedType__fini(&msg->type);
  // speed
  etsi_its_spatem_ts_msgs__msg__SpeedAdvice__fini(&msg->speed);
  // speed_is_present
  // confidence
  etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__fini(&msg->confidence);
  // confidence_is_present
  // distance
  etsi_its_spatem_ts_msgs__msg__ZoneLength__fini(&msg->distance);
  // distance_is_present
  // cls
  etsi_its_spatem_ts_msgs__msg__RestrictionClassID__fini(&msg->cls);
  // cls_is_present
}

bool
etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__are_equal(const etsi_its_spatem_ts_msgs__msg__AdvisorySpeed * lhs, const etsi_its_spatem_ts_msgs__msg__AdvisorySpeed * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // type
  if (!etsi_its_spatem_ts_msgs__msg__AdvisorySpeedType__are_equal(
      &(lhs->type), &(rhs->type)))
  {
    return false;
  }
  // speed
  if (!etsi_its_spatem_ts_msgs__msg__SpeedAdvice__are_equal(
      &(lhs->speed), &(rhs->speed)))
  {
    return false;
  }
  // speed_is_present
  if (lhs->speed_is_present != rhs->speed_is_present) {
    return false;
  }
  // confidence
  if (!etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__are_equal(
      &(lhs->confidence), &(rhs->confidence)))
  {
    return false;
  }
  // confidence_is_present
  if (lhs->confidence_is_present != rhs->confidence_is_present) {
    return false;
  }
  // distance
  if (!etsi_its_spatem_ts_msgs__msg__ZoneLength__are_equal(
      &(lhs->distance), &(rhs->distance)))
  {
    return false;
  }
  // distance_is_present
  if (lhs->distance_is_present != rhs->distance_is_present) {
    return false;
  }
  // cls
  if (!etsi_its_spatem_ts_msgs__msg__RestrictionClassID__are_equal(
      &(lhs->cls), &(rhs->cls)))
  {
    return false;
  }
  // cls_is_present
  if (lhs->cls_is_present != rhs->cls_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__copy(
  const etsi_its_spatem_ts_msgs__msg__AdvisorySpeed * input,
  etsi_its_spatem_ts_msgs__msg__AdvisorySpeed * output)
{
  if (!input || !output) {
    return false;
  }
  // type
  if (!etsi_its_spatem_ts_msgs__msg__AdvisorySpeedType__copy(
      &(input->type), &(output->type)))
  {
    return false;
  }
  // speed
  if (!etsi_its_spatem_ts_msgs__msg__SpeedAdvice__copy(
      &(input->speed), &(output->speed)))
  {
    return false;
  }
  // speed_is_present
  output->speed_is_present = input->speed_is_present;
  // confidence
  if (!etsi_its_spatem_ts_msgs__msg__SpeedConfidenceDSRC__copy(
      &(input->confidence), &(output->confidence)))
  {
    return false;
  }
  // confidence_is_present
  output->confidence_is_present = input->confidence_is_present;
  // distance
  if (!etsi_its_spatem_ts_msgs__msg__ZoneLength__copy(
      &(input->distance), &(output->distance)))
  {
    return false;
  }
  // distance_is_present
  output->distance_is_present = input->distance_is_present;
  // cls
  if (!etsi_its_spatem_ts_msgs__msg__RestrictionClassID__copy(
      &(input->cls), &(output->cls)))
  {
    return false;
  }
  // cls_is_present
  output->cls_is_present = input->cls_is_present;
  return true;
}

etsi_its_spatem_ts_msgs__msg__AdvisorySpeed *
etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_spatem_ts_msgs__msg__AdvisorySpeed * msg = (etsi_its_spatem_ts_msgs__msg__AdvisorySpeed *)allocator.allocate(sizeof(etsi_its_spatem_ts_msgs__msg__AdvisorySpeed), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_spatem_ts_msgs__msg__AdvisorySpeed));
  bool success = etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__destroy(etsi_its_spatem_ts_msgs__msg__AdvisorySpeed * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence__init(etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_spatem_ts_msgs__msg__AdvisorySpeed * data = NULL;

  if (size) {
    data = (etsi_its_spatem_ts_msgs__msg__AdvisorySpeed *)allocator.zero_allocate(size, sizeof(etsi_its_spatem_ts_msgs__msg__AdvisorySpeed), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence__fini(etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence *
etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence * array = (etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence *)allocator.allocate(sizeof(etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence__destroy(etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence__are_equal(const etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence * lhs, const etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence__copy(
  const etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence * input,
  etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_spatem_ts_msgs__msg__AdvisorySpeed);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_spatem_ts_msgs__msg__AdvisorySpeed * data =
      (etsi_its_spatem_ts_msgs__msg__AdvisorySpeed *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_spatem_ts_msgs__msg__AdvisorySpeed__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
