// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_spatem_ts_msgs:msg/AdvisorySpeed.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_spatem_ts_msgs/msg/advisory_speed.hpp"


#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__ADVISORY_SPEED__TRAITS_HPP_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__ADVISORY_SPEED__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_spatem_ts_msgs/msg/detail/advisory_speed__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'type'
#include "etsi_its_spatem_ts_msgs/msg/detail/advisory_speed_type__traits.hpp"
// Member 'speed'
#include "etsi_its_spatem_ts_msgs/msg/detail/speed_advice__traits.hpp"
// Member 'confidence'
#include "etsi_its_spatem_ts_msgs/msg/detail/speed_confidence_dsrc__traits.hpp"
// Member 'distance'
#include "etsi_its_spatem_ts_msgs/msg/detail/zone_length__traits.hpp"
// Member 'cls'
#include "etsi_its_spatem_ts_msgs/msg/detail/restriction_class_id__traits.hpp"

namespace etsi_its_spatem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const AdvisorySpeed & msg,
  std::ostream & out)
{
  out << "{";
  // member: type
  {
    out << "type: ";
    to_flow_style_yaml(msg.type, out);
    out << ", ";
  }

  // member: speed
  {
    out << "speed: ";
    to_flow_style_yaml(msg.speed, out);
    out << ", ";
  }

  // member: speed_is_present
  {
    out << "speed_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_is_present, out);
    out << ", ";
  }

  // member: confidence
  {
    out << "confidence: ";
    to_flow_style_yaml(msg.confidence, out);
    out << ", ";
  }

  // member: confidence_is_present
  {
    out << "confidence_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.confidence_is_present, out);
    out << ", ";
  }

  // member: distance
  {
    out << "distance: ";
    to_flow_style_yaml(msg.distance, out);
    out << ", ";
  }

  // member: distance_is_present
  {
    out << "distance_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.distance_is_present, out);
    out << ", ";
  }

  // member: cls
  {
    out << "cls: ";
    to_flow_style_yaml(msg.cls, out);
    out << ", ";
  }

  // member: cls_is_present
  {
    out << "cls_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cls_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const AdvisorySpeed & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type:\n";
    to_block_style_yaml(msg.type, out, indentation + 2);
  }

  // member: speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed:\n";
    to_block_style_yaml(msg.speed, out, indentation + 2);
  }

  // member: speed_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_is_present, out);
    out << "\n";
  }

  // member: confidence
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "confidence:\n";
    to_block_style_yaml(msg.confidence, out, indentation + 2);
  }

  // member: confidence_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "confidence_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.confidence_is_present, out);
    out << "\n";
  }

  // member: distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance:\n";
    to_block_style_yaml(msg.distance, out, indentation + 2);
  }

  // member: distance_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.distance_is_present, out);
    out << "\n";
  }

  // member: cls
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cls:\n";
    to_block_style_yaml(msg.cls, out, indentation + 2);
  }

  // member: cls_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cls_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.cls_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const AdvisorySpeed & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_spatem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_spatem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_spatem_ts_msgs::msg::AdvisorySpeed & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_spatem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_spatem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_spatem_ts_msgs::msg::AdvisorySpeed & msg)
{
  return etsi_its_spatem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_spatem_ts_msgs::msg::AdvisorySpeed>()
{
  return "etsi_its_spatem_ts_msgs::msg::AdvisorySpeed";
}

template<>
inline const char * name<etsi_its_spatem_ts_msgs::msg::AdvisorySpeed>()
{
  return "etsi_its_spatem_ts_msgs/msg/AdvisorySpeed";
}

template<>
struct has_fixed_size<etsi_its_spatem_ts_msgs::msg::AdvisorySpeed>
  : std::integral_constant<bool, has_fixed_size<etsi_its_spatem_ts_msgs::msg::AdvisorySpeedType>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::RestrictionClassID>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::SpeedAdvice>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::SpeedConfidenceDSRC>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::ZoneLength>::value> {};

template<>
struct has_bounded_size<etsi_its_spatem_ts_msgs::msg::AdvisorySpeed>
  : std::integral_constant<bool, has_bounded_size<etsi_its_spatem_ts_msgs::msg::AdvisorySpeedType>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::RestrictionClassID>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::SpeedAdvice>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::SpeedConfidenceDSRC>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::ZoneLength>::value> {};

template<>
struct is_message<etsi_its_spatem_ts_msgs::msg::AdvisorySpeed>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__ADVISORY_SPEED__TRAITS_HPP_
