// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_spatem_ts_msgs:msg/ConnectionManeuverAssist.idl
// generated code does not contain a copyright notice
#include "etsi_its_spatem_ts_msgs/msg/detail/connection_maneuver_assist__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `connection_id`
#include "etsi_its_spatem_ts_msgs/msg/detail/lane_connection_id__functions.h"
// Member `queue_length`
// Member `available_storage_length`
#include "etsi_its_spatem_ts_msgs/msg/detail/zone_length__functions.h"
// Member `wait_on_stop`
#include "etsi_its_spatem_ts_msgs/msg/detail/wait_on_stopline__functions.h"
// Member `ped_bicycle_detect`
#include "etsi_its_spatem_ts_msgs/msg/detail/pedestrian_bicycle_detect__functions.h"

bool
etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__init(etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist * msg)
{
  if (!msg) {
    return false;
  }
  // connection_id
  if (!etsi_its_spatem_ts_msgs__msg__LaneConnectionID__init(&msg->connection_id)) {
    etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__fini(msg);
    return false;
  }
  // queue_length
  if (!etsi_its_spatem_ts_msgs__msg__ZoneLength__init(&msg->queue_length)) {
    etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__fini(msg);
    return false;
  }
  // queue_length_is_present
  // available_storage_length
  if (!etsi_its_spatem_ts_msgs__msg__ZoneLength__init(&msg->available_storage_length)) {
    etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__fini(msg);
    return false;
  }
  // available_storage_length_is_present
  // wait_on_stop
  if (!etsi_its_spatem_ts_msgs__msg__WaitOnStopline__init(&msg->wait_on_stop)) {
    etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__fini(msg);
    return false;
  }
  // wait_on_stop_is_present
  // ped_bicycle_detect
  if (!etsi_its_spatem_ts_msgs__msg__PedestrianBicycleDetect__init(&msg->ped_bicycle_detect)) {
    etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__fini(msg);
    return false;
  }
  // ped_bicycle_detect_is_present
  return true;
}

void
etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__fini(etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist * msg)
{
  if (!msg) {
    return;
  }
  // connection_id
  etsi_its_spatem_ts_msgs__msg__LaneConnectionID__fini(&msg->connection_id);
  // queue_length
  etsi_its_spatem_ts_msgs__msg__ZoneLength__fini(&msg->queue_length);
  // queue_length_is_present
  // available_storage_length
  etsi_its_spatem_ts_msgs__msg__ZoneLength__fini(&msg->available_storage_length);
  // available_storage_length_is_present
  // wait_on_stop
  etsi_its_spatem_ts_msgs__msg__WaitOnStopline__fini(&msg->wait_on_stop);
  // wait_on_stop_is_present
  // ped_bicycle_detect
  etsi_its_spatem_ts_msgs__msg__PedestrianBicycleDetect__fini(&msg->ped_bicycle_detect);
  // ped_bicycle_detect_is_present
}

bool
etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__are_equal(const etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist * lhs, const etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // connection_id
  if (!etsi_its_spatem_ts_msgs__msg__LaneConnectionID__are_equal(
      &(lhs->connection_id), &(rhs->connection_id)))
  {
    return false;
  }
  // queue_length
  if (!etsi_its_spatem_ts_msgs__msg__ZoneLength__are_equal(
      &(lhs->queue_length), &(rhs->queue_length)))
  {
    return false;
  }
  // queue_length_is_present
  if (lhs->queue_length_is_present != rhs->queue_length_is_present) {
    return false;
  }
  // available_storage_length
  if (!etsi_its_spatem_ts_msgs__msg__ZoneLength__are_equal(
      &(lhs->available_storage_length), &(rhs->available_storage_length)))
  {
    return false;
  }
  // available_storage_length_is_present
  if (lhs->available_storage_length_is_present != rhs->available_storage_length_is_present) {
    return false;
  }
  // wait_on_stop
  if (!etsi_its_spatem_ts_msgs__msg__WaitOnStopline__are_equal(
      &(lhs->wait_on_stop), &(rhs->wait_on_stop)))
  {
    return false;
  }
  // wait_on_stop_is_present
  if (lhs->wait_on_stop_is_present != rhs->wait_on_stop_is_present) {
    return false;
  }
  // ped_bicycle_detect
  if (!etsi_its_spatem_ts_msgs__msg__PedestrianBicycleDetect__are_equal(
      &(lhs->ped_bicycle_detect), &(rhs->ped_bicycle_detect)))
  {
    return false;
  }
  // ped_bicycle_detect_is_present
  if (lhs->ped_bicycle_detect_is_present != rhs->ped_bicycle_detect_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__copy(
  const etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist * input,
  etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist * output)
{
  if (!input || !output) {
    return false;
  }
  // connection_id
  if (!etsi_its_spatem_ts_msgs__msg__LaneConnectionID__copy(
      &(input->connection_id), &(output->connection_id)))
  {
    return false;
  }
  // queue_length
  if (!etsi_its_spatem_ts_msgs__msg__ZoneLength__copy(
      &(input->queue_length), &(output->queue_length)))
  {
    return false;
  }
  // queue_length_is_present
  output->queue_length_is_present = input->queue_length_is_present;
  // available_storage_length
  if (!etsi_its_spatem_ts_msgs__msg__ZoneLength__copy(
      &(input->available_storage_length), &(output->available_storage_length)))
  {
    return false;
  }
  // available_storage_length_is_present
  output->available_storage_length_is_present = input->available_storage_length_is_present;
  // wait_on_stop
  if (!etsi_its_spatem_ts_msgs__msg__WaitOnStopline__copy(
      &(input->wait_on_stop), &(output->wait_on_stop)))
  {
    return false;
  }
  // wait_on_stop_is_present
  output->wait_on_stop_is_present = input->wait_on_stop_is_present;
  // ped_bicycle_detect
  if (!etsi_its_spatem_ts_msgs__msg__PedestrianBicycleDetect__copy(
      &(input->ped_bicycle_detect), &(output->ped_bicycle_detect)))
  {
    return false;
  }
  // ped_bicycle_detect_is_present
  output->ped_bicycle_detect_is_present = input->ped_bicycle_detect_is_present;
  return true;
}

etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist *
etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist * msg = (etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist *)allocator.allocate(sizeof(etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist));
  bool success = etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__destroy(etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence__init(etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist * data = NULL;

  if (size) {
    data = (etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist *)allocator.zero_allocate(size, sizeof(etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence__fini(etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence *
etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence * array = (etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence *)allocator.allocate(sizeof(etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence__destroy(etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence__are_equal(const etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence * lhs, const etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence__copy(
  const etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence * input,
  etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist * data =
      (etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
