// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_spatem_ts_msgs:msg/ConnectionManeuverAssist.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_spatem_ts_msgs/msg/connection_maneuver_assist.hpp"


#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__CONNECTION_MANEUVER_ASSIST__STRUCT_HPP_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__CONNECTION_MANEUVER_ASSIST__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'connection_id'
#include "etsi_its_spatem_ts_msgs/msg/detail/lane_connection_id__struct.hpp"
// Member 'queue_length'
// Member 'available_storage_length'
#include "etsi_its_spatem_ts_msgs/msg/detail/zone_length__struct.hpp"
// Member 'wait_on_stop'
#include "etsi_its_spatem_ts_msgs/msg/detail/wait_on_stopline__struct.hpp"
// Member 'ped_bicycle_detect'
#include "etsi_its_spatem_ts_msgs/msg/detail/pedestrian_bicycle_detect__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist __declspec(deprecated)
#endif

namespace etsi_its_spatem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ConnectionManeuverAssist_
{
  using Type = ConnectionManeuverAssist_<ContainerAllocator>;

  explicit ConnectionManeuverAssist_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : connection_id(_init),
    queue_length(_init),
    available_storage_length(_init),
    wait_on_stop(_init),
    ped_bicycle_detect(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->queue_length_is_present = false;
      this->available_storage_length_is_present = false;
      this->wait_on_stop_is_present = false;
      this->ped_bicycle_detect_is_present = false;
    }
  }

  explicit ConnectionManeuverAssist_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : connection_id(_alloc, _init),
    queue_length(_alloc, _init),
    available_storage_length(_alloc, _init),
    wait_on_stop(_alloc, _init),
    ped_bicycle_detect(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->queue_length_is_present = false;
      this->available_storage_length_is_present = false;
      this->wait_on_stop_is_present = false;
      this->ped_bicycle_detect_is_present = false;
    }
  }

  // field types and members
  using _connection_id_type =
    etsi_its_spatem_ts_msgs::msg::LaneConnectionID_<ContainerAllocator>;
  _connection_id_type connection_id;
  using _queue_length_type =
    etsi_its_spatem_ts_msgs::msg::ZoneLength_<ContainerAllocator>;
  _queue_length_type queue_length;
  using _queue_length_is_present_type =
    bool;
  _queue_length_is_present_type queue_length_is_present;
  using _available_storage_length_type =
    etsi_its_spatem_ts_msgs::msg::ZoneLength_<ContainerAllocator>;
  _available_storage_length_type available_storage_length;
  using _available_storage_length_is_present_type =
    bool;
  _available_storage_length_is_present_type available_storage_length_is_present;
  using _wait_on_stop_type =
    etsi_its_spatem_ts_msgs::msg::WaitOnStopline_<ContainerAllocator>;
  _wait_on_stop_type wait_on_stop;
  using _wait_on_stop_is_present_type =
    bool;
  _wait_on_stop_is_present_type wait_on_stop_is_present;
  using _ped_bicycle_detect_type =
    etsi_its_spatem_ts_msgs::msg::PedestrianBicycleDetect_<ContainerAllocator>;
  _ped_bicycle_detect_type ped_bicycle_detect;
  using _ped_bicycle_detect_is_present_type =
    bool;
  _ped_bicycle_detect_is_present_type ped_bicycle_detect_is_present;

  // setters for named parameter idiom
  Type & set__connection_id(
    const etsi_its_spatem_ts_msgs::msg::LaneConnectionID_<ContainerAllocator> & _arg)
  {
    this->connection_id = _arg;
    return *this;
  }
  Type & set__queue_length(
    const etsi_its_spatem_ts_msgs::msg::ZoneLength_<ContainerAllocator> & _arg)
  {
    this->queue_length = _arg;
    return *this;
  }
  Type & set__queue_length_is_present(
    const bool & _arg)
  {
    this->queue_length_is_present = _arg;
    return *this;
  }
  Type & set__available_storage_length(
    const etsi_its_spatem_ts_msgs::msg::ZoneLength_<ContainerAllocator> & _arg)
  {
    this->available_storage_length = _arg;
    return *this;
  }
  Type & set__available_storage_length_is_present(
    const bool & _arg)
  {
    this->available_storage_length_is_present = _arg;
    return *this;
  }
  Type & set__wait_on_stop(
    const etsi_its_spatem_ts_msgs::msg::WaitOnStopline_<ContainerAllocator> & _arg)
  {
    this->wait_on_stop = _arg;
    return *this;
  }
  Type & set__wait_on_stop_is_present(
    const bool & _arg)
  {
    this->wait_on_stop_is_present = _arg;
    return *this;
  }
  Type & set__ped_bicycle_detect(
    const etsi_its_spatem_ts_msgs::msg::PedestrianBicycleDetect_<ContainerAllocator> & _arg)
  {
    this->ped_bicycle_detect = _arg;
    return *this;
  }
  Type & set__ped_bicycle_detect_is_present(
    const bool & _arg)
  {
    this->ped_bicycle_detect_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__ConnectionManeuverAssist
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ConnectionManeuverAssist_ & other) const
  {
    if (this->connection_id != other.connection_id) {
      return false;
    }
    if (this->queue_length != other.queue_length) {
      return false;
    }
    if (this->queue_length_is_present != other.queue_length_is_present) {
      return false;
    }
    if (this->available_storage_length != other.available_storage_length) {
      return false;
    }
    if (this->available_storage_length_is_present != other.available_storage_length_is_present) {
      return false;
    }
    if (this->wait_on_stop != other.wait_on_stop) {
      return false;
    }
    if (this->wait_on_stop_is_present != other.wait_on_stop_is_present) {
      return false;
    }
    if (this->ped_bicycle_detect != other.ped_bicycle_detect) {
      return false;
    }
    if (this->ped_bicycle_detect_is_present != other.ped_bicycle_detect_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const ConnectionManeuverAssist_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ConnectionManeuverAssist_

// alias to use template instance with default allocator
using ConnectionManeuverAssist =
  etsi_its_spatem_ts_msgs::msg::ConnectionManeuverAssist_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_spatem_ts_msgs

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__CONNECTION_MANEUVER_ASSIST__STRUCT_HPP_
