// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_spatem_ts_msgs:msg/IntersectionState.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_spatem_ts_msgs/msg/intersection_state.hpp"


#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__INTERSECTION_STATE__STRUCT_HPP_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__INTERSECTION_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'name'
#include "etsi_its_spatem_ts_msgs/msg/detail/descriptive_name__struct.hpp"
// Member 'id'
#include "etsi_its_spatem_ts_msgs/msg/detail/intersection_reference_id__struct.hpp"
// Member 'revision'
#include "etsi_its_spatem_ts_msgs/msg/detail/msg_count__struct.hpp"
// Member 'status'
#include "etsi_its_spatem_ts_msgs/msg/detail/intersection_status_object__struct.hpp"
// Member 'moy'
#include "etsi_its_spatem_ts_msgs/msg/detail/minute_of_the_year__struct.hpp"
// Member 'time_stamp'
#include "etsi_its_spatem_ts_msgs/msg/detail/d_second__struct.hpp"
// Member 'enabled_lanes'
#include "etsi_its_spatem_ts_msgs/msg/detail/enabled_lane_list__struct.hpp"
// Member 'states'
#include "etsi_its_spatem_ts_msgs/msg/detail/movement_list__struct.hpp"
// Member 'maneuver_assist_list'
#include "etsi_its_spatem_ts_msgs/msg/detail/maneuver_assist_list__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__IntersectionState __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__IntersectionState __declspec(deprecated)
#endif

namespace etsi_its_spatem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct IntersectionState_
{
  using Type = IntersectionState_<ContainerAllocator>;

  explicit IntersectionState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_init),
    id(_init),
    revision(_init),
    status(_init),
    moy(_init),
    time_stamp(_init),
    enabled_lanes(_init),
    states(_init),
    maneuver_assist_list(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name_is_present = false;
      this->moy_is_present = false;
      this->time_stamp_is_present = false;
      this->enabled_lanes_is_present = false;
      this->maneuver_assist_list_is_present = false;
    }
  }

  explicit IntersectionState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_alloc, _init),
    id(_alloc, _init),
    revision(_alloc, _init),
    status(_alloc, _init),
    moy(_alloc, _init),
    time_stamp(_alloc, _init),
    enabled_lanes(_alloc, _init),
    states(_alloc, _init),
    maneuver_assist_list(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name_is_present = false;
      this->moy_is_present = false;
      this->time_stamp_is_present = false;
      this->enabled_lanes_is_present = false;
      this->maneuver_assist_list_is_present = false;
    }
  }

  // field types and members
  using _name_type =
    etsi_its_spatem_ts_msgs::msg::DescriptiveName_<ContainerAllocator>;
  _name_type name;
  using _name_is_present_type =
    bool;
  _name_is_present_type name_is_present;
  using _id_type =
    etsi_its_spatem_ts_msgs::msg::IntersectionReferenceID_<ContainerAllocator>;
  _id_type id;
  using _revision_type =
    etsi_its_spatem_ts_msgs::msg::MsgCount_<ContainerAllocator>;
  _revision_type revision;
  using _status_type =
    etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator>;
  _status_type status;
  using _moy_type =
    etsi_its_spatem_ts_msgs::msg::MinuteOfTheYear_<ContainerAllocator>;
  _moy_type moy;
  using _moy_is_present_type =
    bool;
  _moy_is_present_type moy_is_present;
  using _time_stamp_type =
    etsi_its_spatem_ts_msgs::msg::DSecond_<ContainerAllocator>;
  _time_stamp_type time_stamp;
  using _time_stamp_is_present_type =
    bool;
  _time_stamp_is_present_type time_stamp_is_present;
  using _enabled_lanes_type =
    etsi_its_spatem_ts_msgs::msg::EnabledLaneList_<ContainerAllocator>;
  _enabled_lanes_type enabled_lanes;
  using _enabled_lanes_is_present_type =
    bool;
  _enabled_lanes_is_present_type enabled_lanes_is_present;
  using _states_type =
    etsi_its_spatem_ts_msgs::msg::MovementList_<ContainerAllocator>;
  _states_type states;
  using _maneuver_assist_list_type =
    etsi_its_spatem_ts_msgs::msg::ManeuverAssistList_<ContainerAllocator>;
  _maneuver_assist_list_type maneuver_assist_list;
  using _maneuver_assist_list_is_present_type =
    bool;
  _maneuver_assist_list_is_present_type maneuver_assist_list_is_present;

  // setters for named parameter idiom
  Type & set__name(
    const etsi_its_spatem_ts_msgs::msg::DescriptiveName_<ContainerAllocator> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__name_is_present(
    const bool & _arg)
  {
    this->name_is_present = _arg;
    return *this;
  }
  Type & set__id(
    const etsi_its_spatem_ts_msgs::msg::IntersectionReferenceID_<ContainerAllocator> & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__revision(
    const etsi_its_spatem_ts_msgs::msg::MsgCount_<ContainerAllocator> & _arg)
  {
    this->revision = _arg;
    return *this;
  }
  Type & set__status(
    const etsi_its_spatem_ts_msgs::msg::IntersectionStatusObject_<ContainerAllocator> & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__moy(
    const etsi_its_spatem_ts_msgs::msg::MinuteOfTheYear_<ContainerAllocator> & _arg)
  {
    this->moy = _arg;
    return *this;
  }
  Type & set__moy_is_present(
    const bool & _arg)
  {
    this->moy_is_present = _arg;
    return *this;
  }
  Type & set__time_stamp(
    const etsi_its_spatem_ts_msgs::msg::DSecond_<ContainerAllocator> & _arg)
  {
    this->time_stamp = _arg;
    return *this;
  }
  Type & set__time_stamp_is_present(
    const bool & _arg)
  {
    this->time_stamp_is_present = _arg;
    return *this;
  }
  Type & set__enabled_lanes(
    const etsi_its_spatem_ts_msgs::msg::EnabledLaneList_<ContainerAllocator> & _arg)
  {
    this->enabled_lanes = _arg;
    return *this;
  }
  Type & set__enabled_lanes_is_present(
    const bool & _arg)
  {
    this->enabled_lanes_is_present = _arg;
    return *this;
  }
  Type & set__states(
    const etsi_its_spatem_ts_msgs::msg::MovementList_<ContainerAllocator> & _arg)
  {
    this->states = _arg;
    return *this;
  }
  Type & set__maneuver_assist_list(
    const etsi_its_spatem_ts_msgs::msg::ManeuverAssistList_<ContainerAllocator> & _arg)
  {
    this->maneuver_assist_list = _arg;
    return *this;
  }
  Type & set__maneuver_assist_list_is_present(
    const bool & _arg)
  {
    this->maneuver_assist_list_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_spatem_ts_msgs::msg::IntersectionState_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_spatem_ts_msgs::msg::IntersectionState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::IntersectionState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::IntersectionState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__IntersectionState
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__IntersectionState
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::IntersectionState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const IntersectionState_ & other) const
  {
    if (this->name != other.name) {
      return false;
    }
    if (this->name_is_present != other.name_is_present) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->revision != other.revision) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    if (this->moy != other.moy) {
      return false;
    }
    if (this->moy_is_present != other.moy_is_present) {
      return false;
    }
    if (this->time_stamp != other.time_stamp) {
      return false;
    }
    if (this->time_stamp_is_present != other.time_stamp_is_present) {
      return false;
    }
    if (this->enabled_lanes != other.enabled_lanes) {
      return false;
    }
    if (this->enabled_lanes_is_present != other.enabled_lanes_is_present) {
      return false;
    }
    if (this->states != other.states) {
      return false;
    }
    if (this->maneuver_assist_list != other.maneuver_assist_list) {
      return false;
    }
    if (this->maneuver_assist_list_is_present != other.maneuver_assist_list_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const IntersectionState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct IntersectionState_

// alias to use template instance with default allocator
using IntersectionState =
  etsi_its_spatem_ts_msgs::msg::IntersectionState_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_spatem_ts_msgs

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__INTERSECTION_STATE__STRUCT_HPP_
