// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_spatem_ts_msgs:msg/MovementEvent.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_spatem_ts_msgs/msg/movement_event.h"


#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_EVENT__STRUCT_H_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_EVENT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'event_state'
#include "etsi_its_spatem_ts_msgs/msg/detail/movement_phase_state__struct.h"
// Member 'timing'
#include "etsi_its_spatem_ts_msgs/msg/detail/time_change_details__struct.h"
// Member 'speeds'
#include "etsi_its_spatem_ts_msgs/msg/detail/advisory_speed_list__struct.h"

/// Struct defined in msg/MovementEvent in the package etsi_its_spatem_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2024 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_spatem_ts_msgs__msg__MovementEvent
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/is_ts103301/SPATEM-PDU-Descriptions.asn
  ///   asn1/raw/is_ts103301/cdd/ITS-Container.asn
  ///   asn1/raw/is_ts103301/iso-patched/ISO24534-3_ElectronicRegistrationIdentificationVehicleDataModule-patched.asn
  ///   asn1/raw/is_ts103301/build/asn1/ISO-TS-19091-addgrp-C-2018-patched.asn
  ///   asn1/patched/is_ts103301/build/asn1/ISO14816_AVIAEINumberingAndDataStructures.asn
  ///   -t
  ///   spatem_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_spatem_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// MovementEvent ::= SEQUENCE {
  ///   eventState   MovementPhaseState,
  ///   timing       TimeChangeDetails OPTIONAL,
  ///   speeds       AdvisorySpeedList OPTIONAL,
  ///   regional     SEQUENCE (SIZE(1..4)) OF
  ///                RegionalExtension {{Reg-MovementEvent}} OPTIONAL,
  /// ------------------------------------------------------------------------------
  etsi_its_spatem_ts_msgs__msg__MovementPhaseState event_state;
  etsi_its_spatem_ts_msgs__msg__TimeChangeDetails timing;
  bool timing_is_present;
  etsi_its_spatem_ts_msgs__msg__AdvisorySpeedList speeds;
  bool speeds_is_present;
} etsi_its_spatem_ts_msgs__msg__MovementEvent;

// Struct for a sequence of etsi_its_spatem_ts_msgs__msg__MovementEvent.
typedef struct etsi_its_spatem_ts_msgs__msg__MovementEvent__Sequence
{
  etsi_its_spatem_ts_msgs__msg__MovementEvent * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_spatem_ts_msgs__msg__MovementEvent__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_EVENT__STRUCT_H_
