// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_spatem_ts_msgs:msg/MovementEvent.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_spatem_ts_msgs/msg/movement_event.hpp"


#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_EVENT__TRAITS_HPP_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_EVENT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_spatem_ts_msgs/msg/detail/movement_event__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'event_state'
#include "etsi_its_spatem_ts_msgs/msg/detail/movement_phase_state__traits.hpp"
// Member 'timing'
#include "etsi_its_spatem_ts_msgs/msg/detail/time_change_details__traits.hpp"
// Member 'speeds'
#include "etsi_its_spatem_ts_msgs/msg/detail/advisory_speed_list__traits.hpp"

namespace etsi_its_spatem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MovementEvent & msg,
  std::ostream & out)
{
  out << "{";
  // member: event_state
  {
    out << "event_state: ";
    to_flow_style_yaml(msg.event_state, out);
    out << ", ";
  }

  // member: timing
  {
    out << "timing: ";
    to_flow_style_yaml(msg.timing, out);
    out << ", ";
  }

  // member: timing_is_present
  {
    out << "timing_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.timing_is_present, out);
    out << ", ";
  }

  // member: speeds
  {
    out << "speeds: ";
    to_flow_style_yaml(msg.speeds, out);
    out << ", ";
  }

  // member: speeds_is_present
  {
    out << "speeds_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.speeds_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MovementEvent & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: event_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "event_state:\n";
    to_block_style_yaml(msg.event_state, out, indentation + 2);
  }

  // member: timing
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timing:\n";
    to_block_style_yaml(msg.timing, out, indentation + 2);
  }

  // member: timing_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timing_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.timing_is_present, out);
    out << "\n";
  }

  // member: speeds
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speeds:\n";
    to_block_style_yaml(msg.speeds, out, indentation + 2);
  }

  // member: speeds_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speeds_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.speeds_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MovementEvent & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_spatem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_spatem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_spatem_ts_msgs::msg::MovementEvent & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_spatem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_spatem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_spatem_ts_msgs::msg::MovementEvent & msg)
{
  return etsi_its_spatem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_spatem_ts_msgs::msg::MovementEvent>()
{
  return "etsi_its_spatem_ts_msgs::msg::MovementEvent";
}

template<>
inline const char * name<etsi_its_spatem_ts_msgs::msg::MovementEvent>()
{
  return "etsi_its_spatem_ts_msgs/msg/MovementEvent";
}

template<>
struct has_fixed_size<etsi_its_spatem_ts_msgs::msg::MovementEvent>
  : std::integral_constant<bool, has_fixed_size<etsi_its_spatem_ts_msgs::msg::AdvisorySpeedList>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::MovementPhaseState>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails>::value> {};

template<>
struct has_bounded_size<etsi_its_spatem_ts_msgs::msg::MovementEvent>
  : std::integral_constant<bool, has_bounded_size<etsi_its_spatem_ts_msgs::msg::AdvisorySpeedList>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::MovementPhaseState>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails>::value> {};

template<>
struct is_message<etsi_its_spatem_ts_msgs::msg::MovementEvent>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_EVENT__TRAITS_HPP_
