// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_spatem_ts_msgs:msg/MovementState.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_spatem_ts_msgs/msg/movement_state.hpp"


#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_STATE__TRAITS_HPP_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_spatem_ts_msgs/msg/detail/movement_state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'movement_name'
#include "etsi_its_spatem_ts_msgs/msg/detail/descriptive_name__traits.hpp"
// Member 'signal_group'
#include "etsi_its_spatem_ts_msgs/msg/detail/signal_group_id__traits.hpp"
// Member 'state_time_speed'
#include "etsi_its_spatem_ts_msgs/msg/detail/movement_event_list__traits.hpp"
// Member 'maneuver_assist_list'
#include "etsi_its_spatem_ts_msgs/msg/detail/maneuver_assist_list__traits.hpp"

namespace etsi_its_spatem_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const MovementState & msg,
  std::ostream & out)
{
  out << "{";
  // member: movement_name
  {
    out << "movement_name: ";
    to_flow_style_yaml(msg.movement_name, out);
    out << ", ";
  }

  // member: movement_name_is_present
  {
    out << "movement_name_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.movement_name_is_present, out);
    out << ", ";
  }

  // member: signal_group
  {
    out << "signal_group: ";
    to_flow_style_yaml(msg.signal_group, out);
    out << ", ";
  }

  // member: state_time_speed
  {
    out << "state_time_speed: ";
    to_flow_style_yaml(msg.state_time_speed, out);
    out << ", ";
  }

  // member: maneuver_assist_list
  {
    out << "maneuver_assist_list: ";
    to_flow_style_yaml(msg.maneuver_assist_list, out);
    out << ", ";
  }

  // member: maneuver_assist_list_is_present
  {
    out << "maneuver_assist_list_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.maneuver_assist_list_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MovementState & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: movement_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "movement_name:\n";
    to_block_style_yaml(msg.movement_name, out, indentation + 2);
  }

  // member: movement_name_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "movement_name_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.movement_name_is_present, out);
    out << "\n";
  }

  // member: signal_group
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "signal_group:\n";
    to_block_style_yaml(msg.signal_group, out, indentation + 2);
  }

  // member: state_time_speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "state_time_speed:\n";
    to_block_style_yaml(msg.state_time_speed, out, indentation + 2);
  }

  // member: maneuver_assist_list
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maneuver_assist_list:\n";
    to_block_style_yaml(msg.maneuver_assist_list, out, indentation + 2);
  }

  // member: maneuver_assist_list_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maneuver_assist_list_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.maneuver_assist_list_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MovementState & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_spatem_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_spatem_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_spatem_ts_msgs::msg::MovementState & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_spatem_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_spatem_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_spatem_ts_msgs::msg::MovementState & msg)
{
  return etsi_its_spatem_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_spatem_ts_msgs::msg::MovementState>()
{
  return "etsi_its_spatem_ts_msgs::msg::MovementState";
}

template<>
inline const char * name<etsi_its_spatem_ts_msgs::msg::MovementState>()
{
  return "etsi_its_spatem_ts_msgs/msg/MovementState";
}

template<>
struct has_fixed_size<etsi_its_spatem_ts_msgs::msg::MovementState>
  : std::integral_constant<bool, has_fixed_size<etsi_its_spatem_ts_msgs::msg::DescriptiveName>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::ManeuverAssistList>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::MovementEventList>::value && has_fixed_size<etsi_its_spatem_ts_msgs::msg::SignalGroupID>::value> {};

template<>
struct has_bounded_size<etsi_its_spatem_ts_msgs::msg::MovementState>
  : std::integral_constant<bool, has_bounded_size<etsi_its_spatem_ts_msgs::msg::DescriptiveName>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::ManeuverAssistList>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::MovementEventList>::value && has_bounded_size<etsi_its_spatem_ts_msgs::msg::SignalGroupID>::value> {};

template<>
struct is_message<etsi_its_spatem_ts_msgs::msg::MovementState>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__MOVEMENT_STATE__TRAITS_HPP_
