// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_spatem_ts_msgs:msg/TimeChangeDetails.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_spatem_ts_msgs/msg/time_change_details.hpp"


#ifndef ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__TIME_CHANGE_DETAILS__STRUCT_HPP_
#define ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__TIME_CHANGE_DETAILS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'start_time'
// Member 'min_end_time'
// Member 'max_end_time'
// Member 'likely_time'
// Member 'next_time'
#include "etsi_its_spatem_ts_msgs/msg/detail/time_mark__struct.hpp"
// Member 'confidence'
#include "etsi_its_spatem_ts_msgs/msg/detail/time_interval_confidence__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__TimeChangeDetails __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_spatem_ts_msgs__msg__TimeChangeDetails __declspec(deprecated)
#endif

namespace etsi_its_spatem_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TimeChangeDetails_
{
  using Type = TimeChangeDetails_<ContainerAllocator>;

  explicit TimeChangeDetails_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start_time(_init),
    min_end_time(_init),
    max_end_time(_init),
    likely_time(_init),
    confidence(_init),
    next_time(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->start_time_is_present = false;
      this->max_end_time_is_present = false;
      this->likely_time_is_present = false;
      this->confidence_is_present = false;
      this->next_time_is_present = false;
    }
  }

  explicit TimeChangeDetails_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start_time(_alloc, _init),
    min_end_time(_alloc, _init),
    max_end_time(_alloc, _init),
    likely_time(_alloc, _init),
    confidence(_alloc, _init),
    next_time(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->start_time_is_present = false;
      this->max_end_time_is_present = false;
      this->likely_time_is_present = false;
      this->confidence_is_present = false;
      this->next_time_is_present = false;
    }
  }

  // field types and members
  using _start_time_type =
    etsi_its_spatem_ts_msgs::msg::TimeMark_<ContainerAllocator>;
  _start_time_type start_time;
  using _start_time_is_present_type =
    bool;
  _start_time_is_present_type start_time_is_present;
  using _min_end_time_type =
    etsi_its_spatem_ts_msgs::msg::TimeMark_<ContainerAllocator>;
  _min_end_time_type min_end_time;
  using _max_end_time_type =
    etsi_its_spatem_ts_msgs::msg::TimeMark_<ContainerAllocator>;
  _max_end_time_type max_end_time;
  using _max_end_time_is_present_type =
    bool;
  _max_end_time_is_present_type max_end_time_is_present;
  using _likely_time_type =
    etsi_its_spatem_ts_msgs::msg::TimeMark_<ContainerAllocator>;
  _likely_time_type likely_time;
  using _likely_time_is_present_type =
    bool;
  _likely_time_is_present_type likely_time_is_present;
  using _confidence_type =
    etsi_its_spatem_ts_msgs::msg::TimeIntervalConfidence_<ContainerAllocator>;
  _confidence_type confidence;
  using _confidence_is_present_type =
    bool;
  _confidence_is_present_type confidence_is_present;
  using _next_time_type =
    etsi_its_spatem_ts_msgs::msg::TimeMark_<ContainerAllocator>;
  _next_time_type next_time;
  using _next_time_is_present_type =
    bool;
  _next_time_is_present_type next_time_is_present;

  // setters for named parameter idiom
  Type & set__start_time(
    const etsi_its_spatem_ts_msgs::msg::TimeMark_<ContainerAllocator> & _arg)
  {
    this->start_time = _arg;
    return *this;
  }
  Type & set__start_time_is_present(
    const bool & _arg)
  {
    this->start_time_is_present = _arg;
    return *this;
  }
  Type & set__min_end_time(
    const etsi_its_spatem_ts_msgs::msg::TimeMark_<ContainerAllocator> & _arg)
  {
    this->min_end_time = _arg;
    return *this;
  }
  Type & set__max_end_time(
    const etsi_its_spatem_ts_msgs::msg::TimeMark_<ContainerAllocator> & _arg)
  {
    this->max_end_time = _arg;
    return *this;
  }
  Type & set__max_end_time_is_present(
    const bool & _arg)
  {
    this->max_end_time_is_present = _arg;
    return *this;
  }
  Type & set__likely_time(
    const etsi_its_spatem_ts_msgs::msg::TimeMark_<ContainerAllocator> & _arg)
  {
    this->likely_time = _arg;
    return *this;
  }
  Type & set__likely_time_is_present(
    const bool & _arg)
  {
    this->likely_time_is_present = _arg;
    return *this;
  }
  Type & set__confidence(
    const etsi_its_spatem_ts_msgs::msg::TimeIntervalConfidence_<ContainerAllocator> & _arg)
  {
    this->confidence = _arg;
    return *this;
  }
  Type & set__confidence_is_present(
    const bool & _arg)
  {
    this->confidence_is_present = _arg;
    return *this;
  }
  Type & set__next_time(
    const etsi_its_spatem_ts_msgs::msg::TimeMark_<ContainerAllocator> & _arg)
  {
    this->next_time = _arg;
    return *this;
  }
  Type & set__next_time_is_present(
    const bool & _arg)
  {
    this->next_time_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__TimeChangeDetails
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_spatem_ts_msgs__msg__TimeChangeDetails
    std::shared_ptr<etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TimeChangeDetails_ & other) const
  {
    if (this->start_time != other.start_time) {
      return false;
    }
    if (this->start_time_is_present != other.start_time_is_present) {
      return false;
    }
    if (this->min_end_time != other.min_end_time) {
      return false;
    }
    if (this->max_end_time != other.max_end_time) {
      return false;
    }
    if (this->max_end_time_is_present != other.max_end_time_is_present) {
      return false;
    }
    if (this->likely_time != other.likely_time) {
      return false;
    }
    if (this->likely_time_is_present != other.likely_time_is_present) {
      return false;
    }
    if (this->confidence != other.confidence) {
      return false;
    }
    if (this->confidence_is_present != other.confidence_is_present) {
      return false;
    }
    if (this->next_time != other.next_time) {
      return false;
    }
    if (this->next_time_is_present != other.next_time_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const TimeChangeDetails_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TimeChangeDetails_

// alias to use template instance with default allocator
using TimeChangeDetails =
  etsi_its_spatem_ts_msgs::msg::TimeChangeDetails_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_spatem_ts_msgs

#endif  // ETSI_ITS_SPATEM_TS_MSGS__MSG__DETAIL__TIME_CHANGE_DETAILS__STRUCT_HPP_
